<?php
/**
 * @package 	JMP Email Login
 * @version 	1.0.0
 * @copyright 	Copyright (C) 2022 JoomHelper.com
 * @license 	GNU 2 or later
 * @author 		JoomHelper
 */

defined('_JEXEC') or die;

use Joomla\CMS\Factory;

class plgSystemEmail extends JPlugin
{
	public function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
    }

	public function onAfterRoute()
	{
		$app = Factory::getApplication();
		//if($app->isClient('administrator')) return;

		$task = $app->input->getCmd("task", "");
		$component = $app->input->getCmd("option", "");
		$username = $app->input->post->getString("username", "");

		if(!filter_var($username, FILTER_VALIDATE_EMAIL)) return;

		if($app->isClient('site') && $task!='user.login') return;

		if($app->isClient('administrator') && $task!='login' && $component!='com_login') return;

		
		$db = Factory::getDbo();
		$query = $db->getQuery(true);

		$query->select('username, email')
			  ->from('#__users')
			  ->where(implode(' OR ', [
			  	'username='.$db->quote($username),
			  	'LOWER(email)='.$db->quote(strtolower($username))
			  ]));

		$rows = $db->setQuery($query)->loadObjectList();

		if(!$rows) return;

		$existU = false;
		$existE = false;

		foreach($rows as $row)
		{
			if($row->username==$username)
				$existU = true;

			if(strtolower($row->email)==strtolower($username))
				$existE = $row->username;
		}


		if($existU) return;
		if($existE!==false)
		{
			$app->input->post->set("username", $existE);
		}
	} 
}